/**
 * Problem: normapprox1
 * Correct solution (must be OK)
 * Author: stgatilov
 *
 * Iterates over all N^2 line intersections, checks goal functions at each point
 * Time: O(N^3)
 */

//#pragma comment(linker, "/STACK:20000000")
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <cstdint>
#include <unordered_set>
#include <cinttypes>
#include <array>
#include <memory>

using namespace std;
typedef long long int64;
#ifdef HOME
    #define E(c) cerr<<#c
    #define Eo(x) cerr<<#x<<" = "<<(x)<<endl
    #define Ef(...) fprintf(stderr, __VA_ARGS__)
#else
    #define E(c) ((void)0)
    #define Eo(x) ((void)0)
    #define Ef(...) ((void)0)
#endif

const int MAXN = 312;

int n;
int X[MAXN], Y[MAXN];

int main(int argc, char **argv) {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &X[i]);
    for (int i = 0; i < n; i++)
        scanf("%d", &Y[i]);

    double minCost = 1e+100;
    double bestK, bestB;
    assert(n >= 2);
    for (int i = 0; i < n; i++)
        for (int j = i+1; j < n; j++) {
            assert(Y[i] != Y[j]);
            double k = double(X[i] - X[j]) / (Y[i] - Y[j]);
            double b = X[i] - k * Y[i];
            double cost = 0.0;
            for (int i = 0; i < n; i++)
                cost += fabs(X[i] - (k * Y[i] + b));
            if (minCost > cost) {
                minCost = cost;
                bestK = k;
                bestB = b;
            }
        }
    assert(minCost < 1e+50);

    printf("%0.15lf %0.15lf %0.15lf\n", minCost, bestK, bestB);
    return 0;
}
