/**
 * Problem: fixheap2
 * Correct solution (must be OK)
 * Author: stgatilov
 *
 * Traverses heap in both directions (limited number of blocks).
 */

//#pragma comment(linker, "/STACK:20000000")
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <cstdint>
#include <unordered_set>
#include <cinttypes>
#include <array>
#include <memory>

using namespace std;
typedef long long int64;
#ifdef HOME
    #define E(c) cerr<<#c
    #define Eo(x) cerr<<#x<<" = "<<(x)<<endl
    #define Ef(...) fprintf(stderr, __VA_ARGS__)
#else
    #define E(c) ((void)0)
    #define Eo(x) ((void)0)
    #define Ef(...) ((void)0)
#endif

//must not exceed QUERY_LIMIT / 4
const int MAXBLOCKS = 30000;

int64 n;
map<int64, int64> answer;

bool reversed;
int64 Get(int64 addr) {
    if (reversed)
        addr = n-1-addr;
    printf("read %lld\n", addr);
    fflush(stdout);
    int64 value;
    scanf("%lld", &value);
    return value;
}

void Traverse() {
    int block = 0;
    int64 pos = 0;
    map<int64, int64> fixes;

    while (pos < n) {
        if (block >= MAXBLOCKS) {
            Ef("%s: too many (%d) hops with %d fixes\n", (reversed ? "backward" : "forward"), block, int(fixes.size()));
            return;
        }

        int64 startLen = Get(pos);
        int64 newPos = pos + startLen + 2;
        if (newPos > n) {
            Ef("%s: out of array after %d hops and %d fixes\n", (reversed ? "backward" : "forward"), block, int(fixes.size()));
            return;
        }
        int64 endLen = Get(newPos - 1);
        if (endLen != startLen) {
            int64 addr = newPos - 1;
            if (reversed)
                addr = n-1-addr;
            fixes[addr] = startLen;
            if (fixes.size() > 10) {
                Ef("%s: too many (%d) fixes after %d hops\n", (reversed ? "backward" : "forward"), int(fixes.size()), block);
                return; //too bad already
            }
        }

        pos = newPos;
        block++;
    }

    Ef("%s: got %d fixes in %d hops\n", (reversed ? "backward" : "forward"), int(fixes.size()), block);
    if (answer.size() > fixes.size())
        answer = fixes;
}

int main(int argc, char **argv) {
    scanf("%lld", &n);

    //two-change solution is always OK
    answer[0] = n-2;
    answer[n-1] = n-2;

    //check if better solution with 0 or 1 change exists
    reversed = false;
    Traverse();
    reversed = true;
    Traverse();

    printf("fix %d\n", int(answer.size()));
    for (auto p : answer)
        printf("%lld %lld\n", p.first, p.second);

    return 0;
}
