/**
 * Problem: basefrac
 * Correct solution (must be OK)
 * Author: stgatilov
 *
 * Generate all good numbers, then use binary search to find them
 */

//#pragma comment(linker, "/STACK:20000000")
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <cstdint>
#include <unordered_set>
#include <cinttypes>
#include <array>
#include <memory>

using namespace std;
typedef long long int64;
#ifdef HOME
    #define E(c) cerr<<#c
    #define Eo(x) cerr<<#x<<" = "<<(x)<<endl
    #define Ef(...) fprintf(stderr, __VA_ARGS__)
#else
    #define E(c) ((void)0)
    #define Eo(x) ((void)0)
    #define Ef(...) ((void)0)
#endif

int n, b;
int64 m;

int primes[32], powers[32];
int pk;
vector<int64> good;

void Gen(int u, int64 x) {
    if (u == pk) {
        good.push_back(x);
        return;
    }
    int64 nx = x;
    for (int i = 0; ; i++) {
        Gen(u+1, nx);
        if (nx > INT64_MAX / primes[u] - 10)
            break;
        nx *= primes[u];
        if (nx > m)
            break;
    }
}

int main(int argc, char **argv) {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d%lld%d", &b, &m, &n);

    for (int i = 2; i*i <= b; i++) {
        int k = 0;
        while (b % i == 0) {
            b /= i;
            k++;
        }
        if (k > 0) {
            primes[pk] = i;
            powers[pk] = k;
            pk++;
        }
    }
    if (b > 1) {
        primes[pk] = b;
        powers[pk] = 1;
        pk++;
    }

    Gen(0, 1LL);
    Ef("Good %d\n", int(good.size()));
    sort(good.begin(), good.end());

    for (int i = 0; i < n; i++) {
        int64 x;
        scanf("%lld", &x);
        int pos = lower_bound(good.begin(), good.end(), x) - good.begin();
        if (pos == good.size())
            printf("-1\n");
        else
            printf("%lld\n", good[pos] - x);
    }

    return 0;
}
