/*
    Wide Siberian Olympiad in Informatics, 2020
    Round: Internet
    Problem: antitrans
    Solution Author: Mikhail Diakov
    Verdict: Must be OK
    Solution: For each test case scan reachability matrix with `for for` in O(N * N).
*/

#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <array>
#include <algorithm>

int main()
{
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);

    static const size_t N_MAX = 200;
    std::array<bool, N_MAX> used;

    int T = 0;
    scanf("%d", &T);
    for (int t = 0; t < T; ++t)
    {
        int N = 0;
        scanf("%d", &N);

        int edges = 0;
        std::fill(begin(used), begin(used) + N, false);
        for (int i = 0; i < N; ++i)
        {
            for (int j = 0; j < N; ++j)
            {
                int r_ij = 0;
                scanf("%d", &r_ij);

                if (j < i + 1 || !r_ij || used[j])
                {
                    continue;
                }

                used[j] = true;
                ++edges;
            }
        }

        printf("%d\n", edges);
    }

    return 0;
}
