/**
 * Problem: flynshoot
 * Correct solution (must be OK)
 * Author: stgatilov
 * Time: O(M N)
 */

#pragma comment(linker, "/STACK:20000000")
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <cstdint>
#include <unordered_set>
#include <cinttypes>
#include <array>
#include <memory>

using namespace std;
typedef long long int64;
#ifdef HOME
    #define E(c) cerr<<#c
    #define Eo(x) cerr<<#x<<" = "<<(x)<<endl
    #define Ef(...) fprintf(stderr, __VA_ARGS__)
#else
    #define E(c) ((void)0)
    #define Eo(x) ((void)0)
    #define Ef(...) ((void)0)
#endif

const int MAXN = 2048;

int n, m;
char matr[MAXN][MAXN];
int k, s, e;
int idx[MAXN][MAXN];
int num[MAXN*MAXN], res[MAXN*MAXN];

int main(int argc, char **argv) {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++)
        scanf("%s", matr[i]);

    memset(idx, -1, n * sizeof(idx[0]));
    k = -1;
    for (int i = 0; i < n; i++) {
        bool going = false;
        for (int j = 0; j < m; j++) {
            if (matr[i][j] == '@') {
                going = false;
            }
            else {
                if (!going)
                    k++;
                going = true;
                idx[i][j] = k;
                if (matr[i][j] == 'm')
                    num[k]++;
                if (matr[i][j] == 'S')
                    s = k;
                if (matr[i][j] == 'E')
                    e = k;
            }
        }
    }
    k++;
    Ef("%d / %d segments (%0.2g)\n", k, n*m, k / double(n*m));

    memset(res, -63, k * sizeof(res[0]));
    res[s] = 0;
    for (int i = 0; i < n - 1; i++)
        for (int j = 0; j < m; j++) {
            int u = idx[i][j];
            if (u < 0) continue;
            int v = idx[i+1][j];
            if (v < 0) continue;
            res[v] = max(res[v], res[u] + num[u]);
        }

    if (res[e] < 0)
        printf("%d\n", -1);
    else
        printf("%d\n", res[e] + num[e]);

    return 0;
}
